import es
import cmdlib
import playerlib
import popuplib
import keyvalues
import soccer.soccer as soccerlib
import psyco
import services
psyco.full()

info = es.AddonInfo()
info.name = "Soccer Goalie Script"
info.version = soccerlib.info.version
info.basename = "soccergoalie2"
info.author = "chrismrulz"

soccerteamskins_enabled = int(soccerlib.config["Core"]["soccerteamskins_enabled"])
spawntele = int(soccerlib.config["Goalie"]["spawntele"])
goalie = soccerlib.config["Goalie"]
tgskin = soccerlib.config["Goalie"]["tgskin"]
ctgskin = soccerlib.config["Goalie"]["ctgskin"]
skins = soccerlib.config["Skins"]
tskin = soccerlib.config["Skins"]["tskin"]
ctskin = soccerlib.config["Skins"]["ctskin"]
goalxm = soccerlib.goalxm
goalxp = soccerlib.goalxp
tgoalym = soccerlib.tgoalym
tgoalyp = soccerlib.tgoalyp
tgoalyp2 = soccerlib.tgoalyp2
ctgoalym = soccerlib.ctgoalym
ctgoalym2 = soccerlib.ctgoalym2
ctgoalyp = soccerlib.ctgoalyp
ingoalxm = soccerlib.ingoalxm
ingoalxp = soccerlib.ingoalxp
ingoalxh = soccerlib.ingoalxh
intgoalym = soccerlib.intgoalym
intgoalyp = soccerlib.intgoalyp
inctgoalym = soccerlib.inctgoalym
inctgoalyp = soccerlib.inctgoalyp
pbx = soccerlib.pbx
pbz = soccerlib.pbz
newpbcty = soccerlib.newpbcty
newpbty = soccerlib.newpbty
tgoalie = 0
ctgoalie = 0
oneteamselect = 0


def importScript(script):
   return __import__('soccer.%s.%s' % (script, script)).__dict__[script].__dict__[script]

def load():
	es.msg('#Green','Soccer Goalie Script On - by Gideon / Toph')
	loadblock()

def loadblock():
	if(es.exists('saycommand', '!gk') != 1):
		cmdlib.registerSayCommand('!gk', gk, 'Shows the GK select menu', 'use_gk', 'ADMIN')
	if(es.exists('clientcommand', 'gk') != 1):
		cmdlib.registerClientCommand('gk', gk, 'Shows the GK select menu', 'use_gk', 'ADMIN')

def unload():
	cmdlib.unregisterClientCommand('gk')
	cmdlib.unregisterSayCommand('!gk')
	es.msg('#Green','Soccer Goalie Script Off')

def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('gk', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isIdAuthorized(x, 'gk')
    else:
        isAuthed = lambda x: False

def gk(userid, args):
	gkPopup = popuplib.easymenu('GK Skins Menu', None, gk_option)
	gkPopup.addoption('gkselect', 'Select Both GK')
	gkPopup.addoption('ctselect', 'Select CT GK')
	gkPopup.addoption('tselect', 'Select T GK')
	gkPopup.addoption('gkcancel', 'Remove GK skins')
	gkPopup.send(userid)
	
def gk_option(userid, choice, popupname):
	if(choice == 'gkselect'):
		gk_select(userid)
	elif(choice == 'ctselect'):
		ct_select(userid)
	elif(choice == 'tselect'):
		t_select(userid)
	elif(choice == 'gkcancel'):
		global tgoalie
		global ctgoalie
		tgoalie = 0
		ctgoalie = 0
		players = playerlib.getPlayerList('#alive')
		for player in players:
			skinloop(player.userid, player.steamid, player.team)
		es.tell(userid, "#green", "Goalkeepers have been removed.")

def ct_select(userid):
	global oneteamselect
	oneteamselect = 1
	ct_menu(userid)

def t_select(userid):
	global oneteamselect
	oneteamselect = 1
	t_menu(userid)

def gk_select(userid):
	global oneteamselect
	oneteamselect = 0
	ct = es.getplayercount(3)
	if(ct > 0):
		ct_menu(userid)
	else:
		t_menu(userid)

def ct_menu(userid):
	ct_players = popuplib.construct('Select the CT goalkeeper', 'players', '#ct', ct_chosen)
	ct_players.send(userid)

def t_menu(userid):
	t_players = popuplib.construct('Select the T goalkeeper', 'players', '#t', t_chosen)
	t_players.send(userid)

def ct_chosen(userid, choice, popupid):
	global ctgoalie
	selection = playerlib.getPlayer(choice)
	if(selection.steamid == 'BOT'):
		ctgoalie = choice
	else:
		ctgoalie = selection.steamid
	selection_name = es.getplayername(choice)
	es.msg('#multi', "#lightgreen%s#green has been set as the #lightgreenCT #greengoalkeeper." % selection_name)
	if(oneteamselect == 0):
		t_players = popuplib.construct('Select the T goalkeeper', 'players', '#t', t_chosen)
		t_players.send(userid)
	skinloop(choice, selection.steamid, selection.teamid)

def t_chosen(userid, choice, popupid):
	t = es.getplayercount(2)
	if(t > 0):
		global tgoalie
		selection = playerlib.getPlayer(choice)
		if(selection.steamid == 'BOT'):
			tgoalie = choice
		else:
			tgoalie = selection.steamid
		selection_name = es.getplayername(choice)
		es.msg('#multi', "#lightgreen%s#green has been set as the #lightgreenT #greengoalkeeper." % selection_name)
		skinloop(choice, selection.steamid, selection.teamid)

def telegoalies():
	if(tgoalie != 0):
		playerlib.getPlayer(es.getuserid(tgoalie)).setLocation([pbx, newpbty, pbz])
	if(ctgoalie != 0):
		playerlib.getPlayer(es.getuserid(ctgoalie)).setLocation([pbx, newpbcty, pbz])

def player_hurt(event_var):
	if(event_var['weapon'] == "knife"):
		if(event_var['es_steamid'] == tgoalie):
			kgkx,kgky,kgkz = es.getplayerlocation(event_var['userid'])
			if(kgkx < goalxp and kgky < tgoalyp and kgkx > goalxm and kgky > tgoalym):
				es.msg('#multi', "#greenPlayer#lightgreen %s #greenknifed the terrorist team keeper:#lightgreen %s" % (event_var['es_attackername'], event_var['es_username']))
			elif(kgkx < goalxp and kgky > tgoalyp and kgkx > ingoalxp and kgky < tgoalyp2):
				es.msg('#multi', "#greenPlayer#lightgreen %s #greenknifed the terrorist team keeper:#lightgreen %s" % (event_var['es_attackername'], event_var['es_username']))
			elif(kgkx > goalxm and kgky > tgoalyp and kgkx < ingoalxm and kgky < tgoalyp2):
				es.msg('#multi', "#greenPlayer#lightgreen %s #greenknifed the terrorist team keeper:#lightgreen %s" % (event_var['es_attackername'], event_var['es_username']))
			elif(kgkx < ingoalxp and kgky < intgoalyp and kgkx > ingoalxm and kgky > intgoalym and kgkz < ingoalxh):
				es.msg('#multi', "#greenPlayer#lightgreen %s #greenknifed the terrorist team keeper:#lightgreen %s" % (event_var['es_attackername'], event_var['es_username']))
		elif(event_var['es_steamid'] == ctgoalie):
			kgkx,kgky,kgkz = es.getplayerlocation(event_var['userid'])
			if(kgkx < goalxp and kgky < ctgoalyp and kgkx > goalxm and kgky > ctgoalym):
				es.msg('#multi',"#greenPlayer#lightgreen %s #greenknifed the counter-terrorist team keeper:#lightgreen %s" % (event_var['es_attackername'], event_var['es_username']))
			elif(kgkx < goalxp and kgky > ctgoalym2 and kgkx > ingoalxp and kgky < ctgoalym):
				es.msg('#multi',"#greenPlayer#lightgreen %s #greenknifed the counter-terrorist team keeper:#lightgreen %s" % (event_var['es_attackername'], event_var['es_username']))
			elif(kgkx > goalxm and kgky > ctgoalym2 and kgkx < ingoalxm and kgky < ctgoalym):
				es.msg('#multi',"#greenPlayer#lightgreen %s #greenknifed the counter-terrorist team keeper:#lightgreen %s" % (event_var['es_attackername'], event_var['es_username']))
			elif(kgkx < ingoalxp and kgky < inctgoalyp and kgkx > ingoalxm and kgky > inctgoalym and kgkz < ingoalxh):
				es.msg('#multi',"#greenPlayer#lightgreen %s #greenknifed the counter-terrorist team keeper:#lightgreen %s" % (event_var['es_attackername'], event_var['es_username']))

def round_start(event_var):
	if(spawntele == 1):
		telegoalies()

def sharegoalies():
	es.set('ctgoalie', ctgoalie)
	es.set('tgoalie', tgoalie)

def activecheck(steamid):
	global tgoalie
	global ctgoalie
	if(steamid == tgoalie):
		tgoalie = 0
	elif(steamid == ctgoalie):
		ctgoalie = 0

def player_disconnect(event_var):
	if(event_var['steamid'] == 'BOT'):
		activecheck(event_var['userid'])
	else:
		activecheck(event_var['networkid'])

def player_spawn(event_var):
	skinloop(int(event_var['userid']), event_var['es_steamid'], int(event_var['es_userteam']))

def skinloop(luserid, lsid, team):
	if(team == 2):
		global tgoalie
		if(lsid == 'BOT'):
			if(luserid == tgoalie):
				playerlib.getPlayer(luserid).setModel(tgskin)
		elif(lsid == tgoalie):
			playerlib.getPlayer(luserid).setModel(tgskin)
		if(soccerteamskins_enabled == 0):
			t_players = playerlib.getPlayerList('#t')
			for players in t_players:
				if(players.steamid == 'BOT'):
					if(players.userid != tgoalie):
						playerlib.getPlayer(players.userid).setModel(tskin)
				elif(players.steamid != tgoalie):
					playerlib.getPlayer(players.userid).setModel(tskin)
		else:
			globals()["soccer.soccerteamskins.soccerteamskins"] = __import__("soccer.soccerteamskins.soccerteamskins", fromlist="*")
			importScript("soccerteamskins").parseskins(luserid, team)
			global tgoalie
			if(lsid == 'BOT'):
				if(luserid == tgoalie):
					playerlib.getPlayer(luserid).setModel(tgskin)
			elif(lsid == tgoalie):
				playerlib.getPlayer(luserid).setModel(tgskin)
	elif(team == 3):
		global ctgoalie
		if(lsid == 'BOT'):
			if(luserid == ctgoalie):
				playerlib.getPlayer(luserid).setModel(ctgskin)
		elif(lsid == ctgoalie):
			playerlib.getPlayer(luserid).setModel(ctgskin)
		if(soccerteamskins_enabled == 0):
			ct_players = playerlib.getPlayerList('#ct')
			for players in ct_players:
				if(players.steamid == 'BOT'):
					if(players.userid != ctgoalie):
						playerlib.getPlayer(players.userid).setModel(ctskin)
				elif(players.steamid != ctgoalie):
					playerlib.getPlayer(players.userid).setModel(ctskin)
		else:
			globals()["soccer.soccerteamskins.soccerteamskins"] = __import__("soccer.soccerteamskins.soccerteamskins", fromlist="*")
			importScript("soccerteamskins").parseskins(luserid, team)
			global ctgoalie
			if(lsid == 'BOT'):
				if(luserid == ctgoalie):
					playerlib.getPlayer(luserid).setModel(ctgskin)
			elif(lsid == ctgoalie):
				playerlib.getPlayer(luserid).setModel(ctgskin)
	sharegoalies()